Resize with 75% quality setting:

> imagequality = "75"

Resize to ~32% (1920px divided by 6016px)

> sizeofimage = "31.915%%" 

Resize thumbnails to 10% (192px)

> sizeofthumb = "10%%"




> convertStringCMD :: [String] -> String -> String -> String -> String -> [String]
> convertStringCMD [] x y o q        = []
> convertStringCMD (a:as) x y "y" q  = ("convert -resize " ++ x ++ " -quality " ++ q ++ " " ++ a ++ " +profile \"*\" output/" ++ a):("convert -resize " ++ y ++ " -quality 50 output/" ++ a ++ " output/thumbs/" ++ a):convertStringCMD as x y "y" q
> convertStringCMD (a:as) x y o q    = ("IF NOT EXIST output/" ++ a ++ " convert -resize " ++ x ++ " -quality " ++ q ++ " " ++ a ++ " +profile \"*\" output/" ++ a):("IF NOT EXIST output/thumbs/" ++ a ++ " convert -resize " ++ y ++ " -quality 50 output/" ++ a ++ " output/thumbs/" ++ a):convertStringCMD as x y o q

> convertStringBash :: [String] -> String -> String -> String -> String -> [String]
> convertStringBash [] x y o q       = []
> convertStringBash (a:as) x y "y" q = ("echo \"" ++ a ++ ": Converting file.\"\nconvert -resize " ++ x ++ " -quality " ++ q ++ " " ++ a ++ " +profile \"*\" output/" ++ a ++ "\n"):("echo \"" ++ a ++ ": Converting thumbnail.\"\nconvert -resize " ++ y ++ " -quality 50 output/" ++ a ++ " output/thumbs/" ++ a ++ "\n"):convertStringBash as x y "y" q
> convertStringBash (a:as) x y o q   = ("if [ -e output/" ++ a ++ " ]\nthen\n  echo \"" ++ a ++ ": File exists already.\"\nelse\n  echo \"" ++ a ++ ": Converting file.\"\n  convert -resize " ++ x ++ " -quality " ++ q ++ " " ++ a ++ " +profile \"*\" output/" ++ a ++ "\nfi\n"):("if [ -e output/thumbs/" ++ a ++ " ]\nthen\n  echo \"" ++ a ++ ": Thumbnail already exists.\"\nelse\n  echo \"" ++ a ++ ": Converting thumbnail.\"\n  convert -resize " ++ y ++ " -quality 50 output/" ++ a ++ " output/thumbs/" ++ a ++ "\nfi\n"):convertStringBash as x y o q



> main :: IO ()
> main = do
>            s <- readFile "dir.txt"
>            putStrLn "CMD- or Bash-Script-Format? (c)md/(b)ash, defaults to bash"
>            form <- getLine
>            putStrLn "Overwrite existing files? (y)es/(n)o, defaults to no"
>            over <- getLine
>            putStrLn ("Picture Size? defaults to " ++ sizeofimage)
>            x <- getLine
>            putStrLn ("Thumbnail Size? defaults to " ++ sizeofthumb)
>            y <- getLine
>            putStrLn ("Quality of resized Pictures? defaults to " ++ imagequality)
>            qual <- getLine
>
>            if (form=="c")
>              then (writeFile "conv.cmd" (unlines (convertStringCMD (words s) (if (x/="") then x else sizeofimage) (if (y/="") then y else sizeofthumb) over (if qual/="" then qual else imagequality))))
>              else (writeFile "conv.sh" ("#!/bin/sh\n\n" ++ (unlines (convertStringBash (words s) (if (x/="") then x else sizeofimage) (if (y/="") then y else sizeofthumb) over (if qual/="" then qual else imagequality)))))






