dir *.jpg /a:-d /o:n /b > dir.txt

compile using
ghc -XHaskell98 tolink.lhs 

> module Main
> where
>
> filename="dir.txt"
> cols=4
> numberofpics=16
> l1="  <td width=\"120\" align=\"center\" valing=\"middle\"><a href=\""
> l2="\" target=\"_blank\"><img src=\""
> l2a="\"><img src=\""
> l3="\"></a></td>\n"
> firstpage=1
> outfiles="pictures"

Alte Farbdefinitionen:
 colorbg="#AAF"
 colortxt="#FFF"
 colorlnk="#F77"
Jetzt NEU:

> colorbg="#111"
> colortxt="#fff"
> colorlnk="#f33"

css=".bigimg { width:100%; object-fit:contain; }\nh2 { margin:2px 0 2px 0; }\nbody { background-color:" ++ colorbg ++ "; color:" ++ colortxt ++ "; }\na, a:hover, a:visited { color:" ++ colorlnk ++ "; }\ntr, td, table { border:0; padding:1px; margin:0; vertical-align:middle; }\n.tab { width:100%; }\n"

> css=".bigimg { max-width:100%; height:70vh; max-height:100%; }\nh2 { margin:2px 0 2px 0; }\nbody { background-color:" ++ colorbg ++ "; color:" ++ colortxt ++ "; }\na, a:hover, a:visited { color:" ++ colorlnk ++ "; }\ntr, td, table { border:0; padding:1px; margin:0; vertical-align:middle; }\n.tab { width:100%; }\ntd { width: 20vw; height: 20vh; border: 3px solid #555; padding: 5px; background-color: #222; margin: auto; }"

> htmlheader="</title>\n<meta name=\"generator\" content=\"tolink - a haskell program by jan beinersdorf\">\n<meta name=\"author\" content=\"jan beinersdorf\">\n<link rel=\"stylesheet\" type=\"text/css\" href=\"style.css\">\n</head>\n<body>\n\n"

> header x pages titel = "<html>\n<head>\n<title>" ++ titel ++ " - " ++ (if (x==(-1)) then "Start Page" else ("Page " ++ (show x)) ) ++ "</title>\n" ++ htmlheader ++ "<div align=\"center\"><h1>" ++ titel ++ "<br />Pictures - " ++ (if (x==(-1)) then "first page" else ("Page " ++ (show x)) ) ++ "</h1>" ++ (if (x>1) then "<a href=\"" ++ outfiles ++ (if (x-1)<10 then ("0" ++ (show (x-1))) else (show (x-1))) ++ ".html\">back</a>" else "first page") ++ " - " ++ (if (x<=pages) then "<a href=\"" ++ outfiles ++ (if x>0 then (if (x+1)<10 then ("0" ++ (show (x+1))) else (show (x+1))) ++ ".html\">next</a>" else "last page") else "<a href=\"" ++ outfiles ++ "01.html\">first page</a>") ++ "<br><br>\n"
>
> footer n s = (if (s=="y") then ("\n<br>\n<br>\n" ++ (linksToPages n 1)) else "\n") ++ "</div>\n</body>\n</html>"
>
> linksToPages :: Int -> Int -> String
> linksToPages p n = if (n>p)
>                      then "<a href=\"" ++ outfiles ++ (if (n<10) then ("0" ++ (show n)) else (show n)) ++ ".html\">page " ++ (show n) ++ "</a>\n"
>                      else "<a href=\"" ++ outfiles ++ (if (n<10) then ("0" ++ (show n)) else (show n)) ++ ".html\">page " ++ (show n) ++ "</a> - " ++ linksToPages p (n+1)


> removeExt :: String -> String -> String
> removeExt as "jpg"  = as
> removeExt as "html" = (findDot as "") ++ "html"
>
> findDot :: String -> String -> String
> findDot ('.':as) bs = reverse ('.':bs)
> findDot (a:as) bs   = findDot as (a:bs)



> tolink :: [String] -> String -> Int -> Int -> String -> String -> String -> ([String], String)
> tolink as s 0 i v b ext           = (as, s)
> tolink [] s n i v b ext           = ([], s)
> tolink (a:as) s n i v b ext
>              | i<=cols            = let (xs, y) = tolink as s (n-1) (i+1) v b ext in (xs, l1 ++ v ++ "/" ++ (removeExt a ext) ++ (if (b=="y") then l2 else l2a) ++ v ++ "/thumbs/" ++ a ++ l3 ++ y)
>              | otherwise          = let (xs, y) = tolink as s (n-1) 2 v b ext in (xs, " </tr>\n <tr>\n" ++ l1 ++ v ++ "/" ++ (removeExt a ext) ++ (if (b=="y") then l2 else l2a) ++ v ++ "/thumbs/" ++ a ++ l3 ++ y)
>
>
> getallpages :: [String] -> Int -> String -> String -> String -> [(String, String, Int)]
> getallpages [] n v b ext          = []
> getallpages all@(a:as) n v b ext
>              | n<10               = ((outfiles++"0"++show(n)++".html"), y, n):(getallpages x (n+1) v b ext)
>              | otherwise          = ((outfiles++show(n)++".html"), y, n):(getallpages x (n+1) v b ext)
>              where (x, y) = tolink all "" numberofpics 1 v b ext
>
> writethem :: [(String, String, Int)] -> Int -> String -> String -> IO ()
> writethem [] pages links titel = do
>                                     writeFile "index.html" ((header (-1) pages titel) ++ "<b><font size=\"+1\"><a href=\"" ++ outfiles ++ "01.html\">Click here for the pictures!</a></font></b>" ++ (footer pages links))
>                                     writeFile "style.css" css
> writethem ((f, s, p):as) pages links titel
>                                = do
>                                     writeFile f ( (header p pages titel) ++ "<table align=\"0\" border=\"0\">\n <tr>\n" ++ s ++ "\n </tr>\n</table>" ++ (footer pages links))
>                                     writethem as pages links titel

> main = do {
>            s <- readFile filename;
>            putStrLn "Target Directory? defaults to /";
>            verz <- getLine;
>            putStrLn "Page Titel:";
>            titel <- getLine;
>            putStrLn "target=\"_blank\"-Links? (y)es/(n)o";
>            blanklinks <- getLine;
>            putStrLn "Link Every Overview Page? (y)es(n)o";
>            linkstoallpages <- getLine;
>            putStrLn "One Page For Every Picture? (y)es/(n)o, defaults to no";
>            onePage <- getLine;
>            -- let all = words s;
>            -- let pages = (length all) `div` numberofpics;
>            writethem (getallpages (words s) firstpage verz blanklinks (if (onePage=="y") then "html" else "jpg")) (((length (words s)) - 1)`div` numberofpics) linkstoallpages titel;
>            if (onePage=="y") then (createPages (words s) "" titel 0) else (putStrLn "")
>           }



> createPages :: [String] -> String -> String -> Int -> IO ()
> createPages (a:b:as) last titel counter =
>  do
>   (writeFile (removeExt a "html") ("<html>\n<head>\n<title>" ++ titel ++ " - " ++ a ++ htmlheader ++ "<div>\n<table class=\"tab\"><tr><td>" ++ (if (last/="") then ("<a href=\"" ++ (removeExt last "html") ++ "\"><img src=\"thumbs/" ++ last ++ "\"></a><br>back") else "first page") ++ "</td><td align=\"center\"><h2>" ++ titel ++ " - " ++ a ++ "</h2>\n<a href=\"" ++ outfiles ++ (if ((counter `div` numberofpics)<9) then "0" else "") ++ (show (counter `div` numberofpics + 1)) ++ ".html\">back to overview</a></td><td valign=\"top\" align=\"right\"><a href=\"" ++ (removeExt b "html") ++ "\"><img src=\"thumbs/" ++ b ++ "\"></a><br>next</td></tr><tr><td colspan=\"3\"><div align=\"center\"><a href=\"" ++ a ++ "\"><img class=\"bigimg\" src=\"" ++ a ++ "\"></a></div></td></tr></table>\n</div>\n</body>\n</html>"))
>   createPages (b:as) a titel (counter+1)
> createPages (b:as) last titel counter =
>   (writeFile (removeExt b "html") ("<html>\n<head>\n<title>" ++ titel ++ " - " ++ last ++ htmlheader ++ "<div>\n<table class=\"tab\"><tr><td>" ++ (if (last/="") then ("<a href=\"" ++ (removeExt last "html") ++ "\"><img src=\"thumbs/" ++ last ++ "\"></a><br>back") else "first page") ++ "</td><td align=\"center\"><h2>" ++ titel ++ " - " ++ b ++ "</h2><a href=\"" ++ outfiles ++ (if ((counter `div` numberofpics)<9) then "0" else "") ++ (show (counter `div` numberofpics + 1)) ++ ".html\">back to overview</a></td><td valign=\"top\" align=\"right\">last page</td></tr><tr><td colspan=\"3\"><div align=\"center\"><a href=\"" ++ b ++ "\"><img class=\"bigimg\" src=\"" ++ b ++ "\"></a></div></td></tr></table>\n</div>\n</body>\n</html>"))



















